SystemOrganization addCategory: #'Satellogic-Seaside'!

WAComponent subclass: #ContentViewComponent
	instanceVariableNames: 'sateliteConsole show'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside'!

!ContentViewComponent class methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:52'!
createForSateliteConsole: aSateliteConsole 
^self new initializeForSateliteConsole: aSateliteConsole.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 17:42'!
changeVisibility
show := show not.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:09'!
commandsLabelsOf: aSubSystemName 
| aNameCollection |
aNameCollection := OrderedCollection with: 'none'.
(sateliteConsole satellite subSystem:aSubSystemName commands) do: [ : aCommand| aNameCollection add: aCommand name  ] .
^ aNameCollection.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:03'!
commandsOf: aSubSystemName 
^sateliteConsole satellite subSystem:aSubSystemName commands.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:52'!
initializeForSateliteConsole: aSateliteConsole
super initialize.
sateliteConsole := aSateliteConsole.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:53'!
isVisible
^show! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:54'!
satelliteConsole
^sateliteConsole! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:59'!
systemLabels
| systemNameCollection |
systemNameCollection := OrderedCollection  with:'none'.
sateliteConsole satellite systems do:[:aSubSystem| systemNameCollection add: aSubSystem name].
^systemNameCollection.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:00'!
systems
^ sateliteConsole satellite systems ! !

ContentViewComponent subclass: #Filter
	instanceVariableNames: 'selectedSystem selectedCommand sateliteConsole show'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside'!

!Filter class methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:14'!
createWithSateliteConsole: aSateliteConsole 
| newFilter |
newFilter := self createForSateliteConsole: aSateliteConsole. 
newFilter setDefaults.! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 17:44'!
awnserFromParsedOutputParameter: aParsedOutputParameter 
aParsedOutputParameter name ,'   ',aParsedOutputParameter value! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 18:41'!
decideFor: anInstructionWrapper 
^( selectedSystem = 'none' or:( anInstructionWrapper  parsedInstruction includesSubstring: selectedSystem)  ) and: (selectedCommand = 'none' or:( anInstructionWrapper  parsedInstruction includesSubstring: selectedCommand) )! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 16:41'!
getWrapperListFrom:aParsedCompoundAwnser 
| aWrapperList |
aWrapperList := OrderedCollection new.
aParsedCompoundAwnser  parsedAnswers keys do: [:aSateliteAwnserKey|  aWrapperList add: ( self wrapperFromCommandCall: aSateliteAwnserKey andParsedAwnser: (aParsedCompoundAwnser  parsedAnswers at:aSateliteAwnserKey )  ) ].
! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 17:41'!
instructionFromCommandCall: aCommandCall
^ aCommandCall subSystem name , ' >> ', aCommandCall command identifier name , ' : ', aCommandCall command input! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 17:58'!
renderContentOn: aCanvas

	
	aCanvas form:[
		
		show ifTrue:[
	
		aCanvas  select 
          	  list: ( self systemsLabels);
			selected: selectedSystem;
			callback: [ :value |selectedSystem := value ]. 
		
			aCanvas submitButton
            	callback: [  ];
            	value: 'find commands'.
		
		aCanvas  select 
        	    list: (self commandsLabelsOf:( selectedSystem ));
			selected: selectedCommand;
			callback: [ :value |selectedCommand := value ]. 
		
		aCanvas submitButton
            	callback: [ ];
            	value: 'filter'.

		].


	aCanvas break.
	
	aCanvas button
            callback: [self changeVisibility ];
            value: 'View Filter  '. 
	].! !

!Filter methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 17:52'!
wrapperFromCommandCall: aCommandCall andParsedAwnser: aParsedAwnser

| anInstruction aCodedInstruction anAwnser aCodedAwnser |
anInstruction := self instructionFromCommandCall: aCommandCall.

aCodedInstruction := (CommandSerializer for: aCommandCall) value.

aCodedAwnser := ByteArray new.

(aParsedAwnser isKindOf:ParsedStruct )
ifTrue:[ aParsedAwnser parsedParameters do: 
	[:outputparam| anAwnser :='   ', self awnserFromParsedOutputParameter:outputparam  
	]. ] 
ifFalse:[anAwnser := self awnserFromParsedOutputParameter:aParsedAwnser.
		aCodedAwnser := (CommandOutputParser for:aParsedAwnser as: WriteStream new  ) parse].



^InstructionWrapper createFor: anInstruction code: aCodedInstruction andAwnser: anAwnser code: aCodedAwnser.! !

ContentViewComponent subclass: #InstructionAdder
	instanceVariableNames: 'selectedSystem selectedCommand inputList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside'!

!InstructionAdder methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:56'!
makeCommandCall
| sateliteDefinition selectedSystemDefinition selectedCommandDefinition |
sateliteDefinition := self satelliteConsole satellite.
selectedSystemDefinition := sateliteDefinition subSystem: selectedSystem .
selectedCommandDefinition := selectedSystemDefinition command: selectedCommand.
^CommandCall for: selectedCommandDefinition from: selectedSystemDefinition in: sateliteDefinition withInputParameters:  inputList.! !

!InstructionAdder methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 11:03'!
renderContentOn: aCanvas

	| parameter |
	aCanvas form:[
		
		aCanvas button
            callback: [self changeVisibility ];
            value: 'Add Instruction  '. 
		aCanvas break.
		
		self isVisible ifTrue:[
			
			aCanvas  select 
          		  list: (self systemsLabels);
			  selected: selectedSystem ;
			 callback: [ :value |selectedSystem := value ]. 
			aCanvas submitButton
           		 callback: [];
          		  value: 'find commands '.	
		     aCanvas  select 
           		 list: (self commandsLabelsOf:( selectedSystem ));
			selected: selectedCommand;
			callback: [ :value |selectedCommand := value ]. 
			aCanvas submitButton
           		 callback: [];
          		  value: 'select command '.
			aCanvas break.	
			aCanvas break.	
				aCanvas text:' enter parameters '.		
			aCanvas textInput
						value: parameter;
						callback: [ :value | 							
							inputList add: value ].
			aCanvas break.
			aCanvas submitButton
           		 callback: [];
          		  value: 'ADD'.
			aCanvas break.
			aCanvas unorderedList with: inputList.
			aCanvas break.
			aCanvas submitButton
           			 callback: [inputList := OrderedCollection new ];
          			  value: 'CLEAR PARAMETERS'.
			aCanvas break.
			aCanvas break.
			aCanvas submitButton
           			 callback: self send. ];
          			  value: 'SEND'.
		]	
		
	! !

!InstructionAdder methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:57'!
send
self satelliteConsole send: (self makeCommandCall).! !

WAComponent subclass: #InstructionWrapper
	instanceVariableNames: 'codedInstruction instruction codedAwnser awnser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside'!

!InstructionWrapper class methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:24'!
createFor: anInstruction code: aCodedInstruction andAwnser: anAwnser code: aCodedAwnser 
^self new initializeWithInstruction: anInstruction coded: aCodedInstruction andAwnser: anAwnser coded: aCodedAwnser.! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:23'!
awnser
^awnser! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:23'!
codedAwnser
^codedAwnser! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:22'!
codedInstruction
^codedInstruction! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:24'!
initializeWithInstruction:anInstruction coded: aCodedInstruction andAwnser: anAwnser coded:aCodedAwnser
super initialize.
instruction:= anInstruction.
codedAwnser := aCodedAwnser.
awnser := anAwnser.
codedInstruction := aCodedInstruction.
! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:23'!
instruction
^instruction! !

!InstructionWrapper methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 00:43'!
renderContentOn: aCanvas

aCanvas text: instruction.
aCanvas break.
aCanvas text: codedInstruction.
aCanvas break.
aCanvas break.
aCanvas text: awnser.
aCanvas break.
aCanvas text: codedAwnser.
aCanvas break.
aCanvas break.
aCanvas break.
! !
